
import org.alice.apis.moveandturn.event.MouseButtonEvent;
import org.alice.apis.moveandturn.event.MouseButtonListener;
import org.alice.apis.moveandturn.*;
import org.alice.virtualmachine.ForEachRunnable;
import org.alice.virtualmachine.DoTogether;
import org.alice.virtualmachine.ForEachTogether;

public class MyScene extends Scene {

    private MySunLight sunLight = new MySunLight();
    private MyGrassyGround grassyGround = new MyGrassyGround();
    private MyCamera camera = new MyCamera();
    private MyBunny2 bunny2 = new MyBunny2();
    private MyCat cat = new MyCat();

    public MyScene() {
        this.performGeneratedSetUp();
        this.performMySetUp();
    }

    protected void performMySetUp() {
    }

    protected void performGeneratedSetUp() {
        this.setName("scene");
        this.setAtmosphereColor(new Color(0.5, 0.5, 1.0));
        this.sunLight.setName("sunLight");
        this.sunLight.setVehicle(this);
        this.sunLight.setLocalPointOfView(new PointOfView(new Quaternion(-0.7071067811865475, 0.0, 0.0, 0.7071067811865476), new Position(0.0, 0.0, 0.0)));
        this.grassyGround.setName("grassyGround");
        this.grassyGround.setVehicle(this);
        this.grassyGround.setLocalPointOfView(new PointOfView(new Quaternion(0.0, 0.0, 0.0, 1.0), new Position(0.0, 0.0, -0.0)));
        this.grassyGround.setColor(new Color(1.0, 1.0, 1.0));
        this.grassyGround.setOpacity(1.0);
        this.camera.setName("camera");
        this.camera.setVehicle(this);
        this.camera.setLocalPointOfView(new PointOfView(new Quaternion(0.0, 0.9968450230602549, 0.07937253933193684, 6.123233995736766E-17), new Position(0.0, 2.56, -16.0)));
        this.bunny2.setName("bunny2");
        this.bunny2.setVehicle(this);
        this.bunny2.setLocalPointOfView(new PointOfView(new Quaternion(0.0, 0.0, 0.0, 1.0), new Position(-1.0595834073123212E-15, -1.3877787807814457E-17, -7.429823324983669)));
        this.bunny2.setColor(new Color(1.0, 1.0, 1.0));
        this.bunny2.setOpacity(1.0);
        this.cat.setName("cat");
        this.cat.setVehicle(this);
        this.cat.setLocalPointOfView(new PointOfView(new Quaternion(0.0, 0.42002462795625695, 0.0, 0.9075127061976642), new Position(-3.664840431278953, 0.11135439993364851, -3.008829394530908)));
        this.cat.setColor(new Color(1.0, 1.0, 1.0));
        this.cat.setOpacity(1.0);
    }
    
    private void click ()
    {
        MyBunny2 b = new MyBunny2();
        b.setVehicle(this);
        b.moveTo (bunny2);
        new NewJFrame().setVisible(true);
    }

    public void run() {
        Window w = new Window ();
        w.setVisible (true);
        w.info (this);
        
        this.bunny2.addMouseButtonListener(new MouseButtonListener() {
            public void mouseButtonClicked(final MouseButtonEvent e) {
                MyScene.this.bunny2.say("hello");
                click ();
            }
        });
        DoTogether.invokeAndWait(new Runnable() {
            public void run() {
                while (true)
                {
                for (Integer i = 0; i < 4; i++) {
                    MyScene.this.bunny2.move(MoveDirection.FORWARD, 2.0);
                    MyScene.this.bunny2.turn(TurnDirection.RIGHT, 0.25);
                }
                }
            }
        }, new Runnable() {
            public void run() {
                for (Integer i = 0; i < 4; i++) {
                    MyScene.this.cat.move(MoveDirection.FORWARD, 0.5);
                    MyScene.this.cat.turn(TurnDirection.LEFT, 0.25);
                }
            }
        });
        
        

        

    }
}
