
// NO import edu.cmu.cs.dennisc.scenegraph.*;
import javax.swing.tree.*;
import org.alice.apis.moveandturn.*;
import java.lang.reflect.*;

public class Window extends javax.swing.JFrame {

    public Window() {
        initComponents();
    }
    
    DefaultTreeModel model;
    DefaultMutableTreeNode act;
    
    public void open (Object s)
    {
        DefaultMutableTreeNode node = new DefaultMutableTreeNode (s);
        if (model == null)
        {
            model = new DefaultTreeModel (node);
            jTree1.setModel (model);
        }
        else
        {
            int inx = act.getChildCount();
            model.insertNodeInto (node, act, inx);
        }
        act = node;
    }
    
    public void put (Object s)
    {
        DefaultMutableTreeNode node = new DefaultMutableTreeNode (s);
        int inx = act.getChildCount();
        model.insertNodeInto (node, act, inx);
    }

    public void close ()
    {
       act = (DefaultMutableTreeNode) act.getParent();
    }
    
    public void detail (Composite c)
    {
        // import org.alice.apis.moveandturn.*;
        open (c.getName());

        Class cls = c.getClass();
        open ("methods of " + cls.getName());
        // import java.lang.reflect.*;
        Method [] list = cls.getMethods();
        for (Method m : list)
        {
            MyNode node = new MyNode ();
            node.name = m.getName();
            node.obj = c;
            node.met = m;
            open (node);
            Parameter [] params =  m.getParameters();
            for (Parameter p : params)
                put ("param " + p.getType().getSimpleName());
            put ("result " + m.getReturnType().getSimpleName());
            
            if (m.getParameterCount() == 0 && m.getName().startsWith("get"))
            {
                try
                {
                    Object value = m.invoke (c);
                    put ("value " + value);
                }
                catch (Exception ex)
                {
                }
            }
            
            
            close ();
        }
        close ();
        
        Transformable [] a = c.getComponents();
        for (Transformable t : a)
        {
            if (t instanceof Composite)
                detail ( (Composite) t );
            else
                put ("" + a);
        }
        close ();
    }
    
    public void info (Composite c)
    {
        /*
        open ("Abc");
                put ("item 1");
                put ("item 2");
                open ("Klm");
                    put ("item 3");
                close ();
                put ("item 4");
        close ();
        */
        // import org.alice.apis.moveandturn.*;
        detail (c);
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jTextField1 = new javax.swing.JTextField();
        jCheckBox1 = new javax.swing.JCheckBox();
        jSlider1 = new javax.swing.JSlider();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTree1ValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jTree1);

        jTextField1.setText("jTextField1");

        jCheckBox1.setText("jCheckBox1");

        jButton1.setText("jButton1");

        jButton2.setText("set value");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 830, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addComponent(jTextField1)
                                .addComponent(jCheckBox1)
                                .addComponent(jSlider1, javax.swing.GroupLayout.DEFAULT_SIZE, 364, Short.MAX_VALUE))
                            .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 102, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 222, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 405, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSlider1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jCheckBox1)
                .addGap(18, 18, 18)
                .addComponent(jButton1)
                .addGap(18, 18, 18)
                .addComponent(jButton2)
                .addContainerGap(63, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTree1ValueChanged
        TreePath p = evt.getPath();
        Object t = p.getLastPathComponent();
        if (t instanceof DefaultMutableTreeNode)
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode) t;
            if (n.getUserObject() instanceof MyNode)
            {
                MyNode u = (MyNode) n.getUserObject();
                jButton1.setText (u.name);
            }
        }
    }//GEN-LAST:event_jTree1ValueChanged

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSlider jSlider1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables
}
